package sun.tools.jar;

import java.io.StreamTokenizer;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.List;
import java.io.IOException;
import java.util.ArrayList;

public class CommandLine
{
    public CommandLine() {
    }
    
    public static String[] parse(String[] array) throws IOException {
        ArrayList list = new ArrayList(array.length);
        for (int i = 0; i < array.length; ++i) {
            String s = array[i];
            if (s.length() > 1 && s.charAt(0) == '@') {
                String substring = s.substring(1);
                if (substring.charAt(0) == '@') {
                    list.add(substring);
                }
                else {
                    loadCmdFile(substring, list);
                }
            }
            else {
                list.add(s);
            }
        }
        return (String[])list.toArray(new String[list.size()]);
    }
    
    private static void loadCmdFile(String fileName, List<String> list) throws IOException {
        BufferedReader r = new BufferedReader(new FileReader(fileName));
        StreamTokenizer streamTokenizer = new StreamTokenizer(r);
        streamTokenizer.resetSyntax();
        streamTokenizer.wordChars(32, 255);
        streamTokenizer.whitespaceChars(0, 32);
        streamTokenizer.commentChar(35);
        streamTokenizer.quoteChar(34);
        streamTokenizer.quoteChar(39);
        while (streamTokenizer.nextToken() != -1) {
            list.add(streamTokenizer.sval);
        }
        r.close();
    }
}
